﻿using HeuristicLab.Common;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Robocode
{
    [StorableClass]
    public class SetAdjustGunForRobotTurn : Symbol
    {
        public override int MinimumArity { get { return 1; } }
        public override int MaximumArity { get { return 1; } }

        [StorableConstructor]
        private SetAdjustGunForRobotTurn(bool deserializing) : base(deserializing) { }
        private SetAdjustGunForRobotTurn(SetAdjustGunForRobotTurn original, Cloner cloner)
            : base(original, cloner)
        {
        }

        public SetAdjustGunForRobotTurn()
            : base("SetAdjustGunForRobotTurn", "Sets the gun to turn independent from the robot's turn.")
        {
        }

        public override IDeepCloneable Clone(Cloner cloner)
        {
            return new SetAdjustGunForRobotTurn(this, cloner);
        }
    }
}