﻿using HeuristicLab.Common;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Robocode
{
    [StorableClass]
    public class DoNothing : CodeNode
    {
        public override int MinimumArity { get { return 0; } }
        public override int MaximumArity { get { return 0; } }

        [Storable]
        public override string Prefix { get; set; }

        [Storable]
        public override string Suffix { get; set; }

        [StorableConstructor]
        private DoNothing(bool deserializing) : base(deserializing) { }
        private DoNothing(DoNothing original, Cloner cloner)
            : base(original, cloner)
        {
        }

        public DoNothing()
            : base("DoNothing", "Do nothing this turn, meaning that the robot will skip it's turn.")
        {
        }

        public override IDeepCloneable Clone(Cloner cloner)
        {
            return new DoNothing(this, cloner);
        }

        public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children)
        {
            return "";
        }
    }
}